'use strict';
function TouchController($scope){
	var contextMenu = document.querySelector("#contextMenu");
	var contextOverlay = document.querySelector("#contextOverlay");
	var touchContainer = document.getElementById("touchContainer");
	var ngFieldContainer = angular.element(touchContainer);
	var startEvent;
	var hasTouches;
	var selectedPlayerId;
	var contextVisible = false;

	var holdTimeout;

	angular.element(document.body).bind(touchstart, function(event){
		if(["touchContainer", "fieldCanvas"].indexOf(angular.element(event.target).attr("id")) === -1){ return; } //ie9 fix
		StopEvent(event);

		hasTouches = !!event.touches;
		if(!hasTouches && (event.which == 3 || event.which == 2)){ return; }

		startEvent = {
			x: (hasTouches ? event.touches[0].clientX : event.clientX) - GetElementOffset(touchContainer, "offsetLeft"),
			y: (hasTouches ? event.touches[0].clientY : event.clientY) - GetElementOffset(touchContainer, "offsetTop")
		};

		contextVisible = true;

		holdTimeout = setTimeout(function(){
			if(!contextVisible){ return; }
			contextMenu.style.left = startEvent.x + "px";
			contextMenu.style.top = startEvent.y + "px";
			contextMenu.style.zIndex = 300;
			contextOverlay.style.zIndex = 200;

			var playerList = contextMenu.querySelectorAll(".player");
			var playerWidth = playerList[0] ? playerList[0].offsetWidth : 0;
			var playerHeight = playerList[0] ? playerList[0].offsetHeight : 0;
			var xDistance = contextSpacing + (playerWidth);
			var yDistance = contextSpacing + (playerHeight);

			var xShift = 0;
			var yShift = 0;

			if(startEvent.y - (playerWidth + playerWidth/2 + contextSpacing) < 0)								{ yShift = (playerWidth + playerWidth/2) - startEvent.y + contextSpacing; }
			if(startEvent.x - (playerWidth + playerWidth/2 + contextSpacing) < 0)								{ xShift = (playerWidth + playerWidth/2) - startEvent.x + contextSpacing; }
			if(startEvent.y + (playerWidth + playerWidth/2 + contextSpacing) > touchContainer.offsetHeight)			{ yShift = (touchContainer.offsetHeight - startEvent.y) - (playerWidth + playerWidth/2 + contextSpacing); }
			if(startEvent.x + (playerWidth + playerWidth/2 + contextSpacing) > touchContainer.offsetWidth)			{ xShift = (touchContainer.offsetWidth - startEvent.x) - (playerWidth + playerWidth/2 + contextSpacing); }

			var count = 0;
			for(var y = -1; y <= 1; y++){
				for(var x = -1; x <= 1; x++){
					if(!(x == 0 && y == 0) && !(x == 0 && y == 1)){
						document.getElementById("context-" + count).style.left = (x * xDistance - contextSpacing/2 + xShift) + "px";
						document.getElementById("context-" + count).style.top = (y * yDistance - contextSpacing/2 + yShift) + "px";
						count++;
					}
				}
			}
			angular.element(document.getElementById("passBack")).css({
				top: (yDistance - contextSpacing/2 + yShift) + "px",
				left: (-contextSpacing/2 + xShift) + "px"
			});

		}, 300);
	});
	ngFieldContainer.bind(touchmove, function(event){
		if(!contextVisible){ return; }
		var hoverElement = CheckParent(document.elementFromPoint(hasTouches ? event.touches[0].clientX : event.clientX, event.touches ? event.touches[0].clientY : event.clientY), "player");
		selectedPlayerId = angular.element(hoverElement).attr("data-player-id");
		angular.element(touchContainer.querySelectorAll(".hover")).removeClass("hover");
		angular.element(hoverElement).addClass("hover");
	});
	ngFieldContainer.bind(touchend, function(event){
		clearTimeout(holdTimeout);
		StopEvent(event);
		if(!contextVisible){ return; }
		contextVisible = false;
		contextMenu.style.zIndex = '-1000';
		contextOverlay.style.zIndex = '-1000';

		$scope.$apply(function(){
			$scope.points.newAction(selectedPlayerId, Math.round(startEvent.x / (touchContainer.offsetWidth) * fieldPositionPrecision), Math.round(startEvent.y / touchContainer.offsetHeight * fieldPositionPrecision));
		});
		angular.element(touchContainer.querySelectorAll(".hover")).removeClass("hover");
		selectedPlayerId = null;
	});
}