'use strict';

var currentAppVersion = "1.1.1";

var hostName = "www.ultiapps.com";
hostName = window.location.hostname === "localhost" ? "localhost:8083" : hostName;
hostName = window.location.hostname === "192.168.0.101" ? "192.168.0.101:8083" : hostName;
hostName = window.location.hostname === "99.242.66.223" ? "99.242.66.223" : hostName;

for(var key in localizationObject.enUs){
	if(!localizationObject.frCa[key]){
		localizationObject.frCa[key] = localizationObject.enUs[key];
	}
}

angular.module('statTracker', ['st_calendar', 'st_time', 'localization', 'filters', 'storage', 'game'])
	.config(['$routeProvider', function ($routeProvider) {
		$routeProvider
			.when('/'																, {templateUrl: './partials/main.html?v=' + v, controller: MainController})
			.when('/teams/:teamId/games/:gameId'									, {templateUrl: './scripts/modules/game/game.html?v=' + v, controller: PlayGameController})
			.otherwise({redirectTo:'/'});
	}])
	.directive('quickLink', function($rootScope, $location){
		return {
			restrict:'A',
			link:function (scope, element, attributes) {
				new FastClick(element, function(){
					currentScroll = document.getElementById("mainContent").scrollTop;
					if($location.path() === attributes.quickLink){
						var temp = attributes.quickLink.split('/');
						temp.pop();
						$location.path(temp.join("/"));
					}
					else{
						$location.path(attributes.quickLink);
					}
					$rootScope.$apply();
				});
			}
		};
	})
	.directive('quickTap', function () {
		return {
			restrict:'A',
			link:function (scope, element, attributes) {
				new FastClick(element, function(){ scope.$apply(attributes.quickTap); });
			}
		};
	});
function GlobalController($scope, $http, ST_Localization){
	ST_Localization.Init();

	document.addEventListener("deviceready", function(){
		CheckVersion($scope, $http);
		setInterval(function(){ CheckVersion($scope, $http); }, 1000*60*60*24);
	}, false);
}

function CheckVersion($scope, $http){
	$http.post("http://" + hostName + "/version.php")
		.success(function(data){
			var displayErrorMessage = false;

			if(data){
				var temp = eval(data);
				if(typeof(window.device) !== "undefined" && window.device.platform){
					var platform = window.device.platform.toLowerCase();
					if(temp[platform]){
						if(!IsNewer(temp[platform], currentAppVersion)){
							displayErrorMessage =  true;
						}
					}
					else if(!IsNewer(temp["general"], currentAppVersion)){
						displayErrorMessage = true;
					}
				}
				else{
					if(isMobile.Android()){
						if(!IsNewer(temp["android"], currentAppVersion)){
							displayErrorMessage = true;
						}
					}
					else if(isMobile.iOS()){
						if(!IsNewer(temp["iphone"], currentAppVersion)){
							displayErrorMessage = true;
						}
					}
					else if(!IsNewer(temp["general"], currentAppVersion)){
						displayErrorMessage = true;
					}
				}
			}
			if(displayErrorMessage){
				alert($scope.localization.get("thereIsAnUpgrade"));
			}
		});
}

var settingsEmailInput;
var settingsPasswordInput;
var teamNameInput;
var opponentNameInput;
var playerNameInput;
var playerFirstNameInput;
var playerLastNameInput;
var playerNumberInput;

function MainController($scope, $routeParams, ST_Storage, $location, $http) {

	settingsEmailInput = document.getElementById("settingsEmailInput");
	settingsPasswordInput = document.getElementById("settingsPasswordInput");
	teamNameInput = document.getElementById("teamNameInput");
	opponentNameInput = document.getElementById("opponentNameInput");
	playerNameInput = document.getElementById("playerNameInput");
	playerFirstNameInput = document.getElementById("playerFirstNameInput");
	playerLastNameInput = document.getElementById("playerLastNameInput");
	playerNumberInput = document.getElementById("playerNumberInput");


	$scope.storage 			= ST_Storage;
	$scope.teamSizes 		= teamSizes;
	$scope.playerLines 		= playerLines;
	$scope.playerTypes 		= playerTypes;
	$scope.strategy 		= strategy;
	$scope.maxStorageSize 	= maxStorageSize;
	$scope.showTeam 		= $routeParams.teamId;

	$scope.team = {};
	$scope.game = {};

	$scope.teamId = 0;

	$scope.toggleSettings = function(){
		$scope.showSettings = !$scope.showSettings;
	};

	$scope.displayEditTeam = false;
	$scope.displayEditOpponent = false;
	$scope.displayEditPlayer = false;

	$scope.selectTeam = function(teamId){
		$scope.teamId = teamId;
		$scope.team = ST_Storage.getTeam($scope.teamId);
	};
	$scope.editTeam = function(teamId){
		$scope.teamId = teamId;
		$scope.team = teamId ? ST_Storage.getTeam(teamId) : { size: 7};

		teamNameInput.value = $scope.team.name ? $scope.team.name : "";
		$scope.displayEditTeam = true;
	};
	$scope.selectTeamGames = function(){
		$scope.showGames = $scope.teamId;
		$scope.showOpponents = false;
		$scope.showPlayers = false;
	};
	$scope.editTeamGame = function(gameId){
		$scope.team = ST_Storage.getTeam($scope.teamId);
		$scope.gameId = gameId;
		$scope.game = gameId ? Clone(ST_Storage.getGame(gameId)) : {date:"", time:""};
		$scope.displayEditGame = true;
		document.getElementById("gameOpponentId").value = $scope.game.opponentId;
	};
	$scope.selectTeamOpponents = function(teamId){
		$scope.showGames = false;
		$scope.showOpponents = $scope.teamId;
		$scope.showPlayers = false;
	};
	$scope.editTeamOpponent = function(opponentId){
		$scope.team = ST_Storage.getTeam($scope.teamId);
		$scope.displayEditOpponent = true;
		$scope.opponent = opponentId ? Clone(ST_Storage.getTeamKey($scope.teamId, "opponents", opponentId)) : {};
		opponentNameInput.value = $scope.opponent.name ? $scope.opponent.name : "";
	};
	$scope.selectTeamPlayers = function(teamId){
		$scope.showGames = false;
		$scope.showOpponents = false;
		$scope.showPlayers = $scope.teamId;
	};
	$scope.editTeamPlayer = function(playerId){
		$scope.team = ST_Storage.getTeam($scope.teamId);
		$scope.displayEditPlayer = true;
		$scope.player = playerId ? Clone(ST_Storage.getTeamKey($scope.teamId, "players", playerId)) : {};

		playerNameInput.value = $scope.player.name ? $scope.player.name : "";
		playerFirstNameInput.value = $scope.player.firstName ? $scope.player.firstName : "";
		playerLastNameInput.value = $scope.player.lastName ? $scope.player.lastName : "";
		playerNumberInput.value = $scope.player.number ? $scope.player.number : "";
	};

	$scope.addDemoData = function(){
		var gameInfo = ST_Storage.addDemoData();
		$location.path("/teams/" + gameInfo.teamId + "/games/" + gameInfo.gameId);
	};

	EditTeamController($scope, ST_Storage);
	EditGameController($scope, ST_Storage);
	EditOpponentController($scope, ST_Storage);
	EditPlayerController($scope, ST_Storage);

	AndroidTouchScrollElement(document.getElementById("mainContent"));
}
function EditTeamController($scope, ST_Storage) {
	$scope.teamName = $scope.team.name ? "" + $scope.team.name : "";

	$scope.cancelTeam = function () {
		$scope.displayEditTeam = false;
	};

	$scope.saveTeam = function () {
		var errorMsg = "";

		$scope.team.name = teamNameInput.value;

		if (!$scope.team || !$scope.team.name) { 	errorMsg += "\n- " + $scope.localization.get("youMustChooseATeamSize"); }
		if (!$scope.team || !$scope.team.size) { 	errorMsg += "\n- " + $scope.localization.get("youMustSpecifyALineSize"); }
		if (errorMsg.length === 0) {
			ST_Storage.saveTeam($scope.teamId ? $scope.teamId : undefined, $scope.team);
			$scope.cancelTeam();
		}
		else {
			alert($scope.localization.get("pleaseFixTheFollowingErrors") + errorMsg);
		}
	};
	$scope.deleteTeam = function () {
		if (confirm($scope.localization.get("areYouSureYouWantToDelete",[$scope.teamName]))) {
			ST_Storage.deleteTeam($scope.teamId);
			$scope.cancelTeam();
			$scope.teamId = null;
		}
	};
}
function EditGameController($scope, ST_Storage) {
	$scope.cancelGame = function () {
		$scope.displayEditGame = false;
	};
	$scope.saveGame = function(skipCancel){
		var errorMsg = "";
		if(!$scope.game || !$scope.game.opponentId){
			errorMsg += "\n - " + $scope.localization.get("youMustChooseAnOpponent");
		}
		if (errorMsg.length === 0) {
			$scope.gameId = ST_Storage.saveGame($scope.teamId, null, $scope.gameId, $scope.game);
			if(!skipCancel){ $scope.cancelGame(); }
			return true;
		}
		else {
			alert($scope.localization.get("pleaseFixTheFollowingErrors") + errorMsg);
			return false;
		}
	};
	$scope.deleteGame = function(){
		if(confirm($scope.localization.get("areYouSureYouWantToDeleteGame"))){
			ST_Storage.deleteGame($scope.gameId);
			$scope.cancelGame();
		}
	};
}
function EditOpponentController($scope, ST_Storage) {
	$scope.cancelOpponent = function(){
		$scope.displayEditOpponent = false;
	};
	$scope.saveOpponent = function(){
		var errorMsg = "";

		$scope.opponent.name = opponentNameInput.value;

		if(!$scope.opponent.name){ errorMsg += "\n - " + $scope.localization.get("youMustChooseA", ["name"])}
		if(errorMsg.length === 0){
			ST_Storage.saveTeamKey($scope.teamId, "opponents", $scope.opponent.id, $scope.opponent);
			$scope.cancelOpponent();
		}
		else{
			alert($scope.localization.get("pleaseFixTheFollowingErrors") + errorMsg);
		}
	};
	$scope.deleteOpponent = function(){
		if (confirm($scope.localization.get("areYouSureYouWantToDelete",[$scope.opponent.name]))) {
			ST_Storage.deleteTeamKey($scope.teamId, "opponents", $scope.opponent.id);
			$scope.cancelOpponent();
		}
	};
}
function EditPlayerController($scope, ST_Storage) {
	$scope.cancelPlayer = function(){
		$scope.displayEditPlayer = false;
	};
	$scope.savePlayer = function(){
		var errorMsg = "";

		$scope.player.name = playerNameInput.value;
		$scope.player.firstName = playerFirstNameInput.value;
		$scope.player.lastName = playerLastNameInput.value;
		$scope.player.number = playerNumberInput.value;

		if(!$scope.player.name){ errorMsg += "\n - " + $scope.localization.get("youMustChooseA", ["nickname"])}
		if(errorMsg.length === 0){
			ST_Storage.saveTeamKey($scope.teamId, "players", $scope.player.id, $scope.player);
			$scope.cancelPlayer();
		}
		else{
			alert($scope.localization.get("pleaseFixTheFollowingErrors") + errorMsg);
		}
	};
	$scope.deletePlayer = function(){
		if (confirm($scope.localization.get("areYouSureYouWantToDelete",[$scope.player.name]))) {
			ST_Storage.deleteTeamKey($scope.teamId, "players", $scope.player.id);
			$scope.cancelPlayer();
		}
	};
}
function SettingsController($scope, $http, ST_Storage, ST_Localization){
	$scope.account = ST_Storage.getAccount();

	$scope.currentLocalization = ST_Localization.currentLocalization;
	$scope.changeLocalization = function(){
		ST_Localization.getLocalization($scope.currentLocalization);
	};

	$scope.deleteData = function(){
		if(confirm($scope.localization.get("areYouSureYouWantToDeleteData"))){
			ST_Storage.deleteData();
		}
	};

	$scope.syncData = function(){
		if(confirm($scope.localization.get("thisWillUseYourDataPlan"))){
			Post($scope, $http, ST_Storage, ST_Localization);
		}
	};
}
function Post($scope, $http, ST_Storage, ST_Localization){
	ST_Storage.saveAccount($scope.account);

	$http.post("http://" + hostName + "/sync/", {data: ST_Storage.cleanData(), account: {email: settingsEmailInput.value, password: settingsPasswordInput.value}})
		.success(function(data, status, headers, config){
			if(data.error === ""){
				var teamsAdded = 0;
				var playersAdded = 0;
				var opponentsAdded = 0;
				var gamesAdded = 0;

				if(data.teams){
					for(var x = 0, xLen = data.teams.length; x < xLen; x++){
						ST_Storage.saveTeam(data.teams[x].id, data.teams[x]);
						teamsAdded++;
					}
				}
				if(data.players){
					for(var x = 0, xLen = data.players.length; x < xLen; x++){
						ST_Storage.saveTeamKey(data.players[x].teamId, "players", data.players[x].id, data.players[x]);
						playersAdded++;
					}
				}
				if(data.opponents){
					for(var x = 0, xLen = data.opponents.length; x < xLen; x++){
						ST_Storage.saveTeamKey(data.opponents[x].teamId, "opponents", data.opponents[x].id, data.opponents[x]);
						opponentsAdded++;
					}
				}
				if(data.games){
					for(var x = 0, xLen = data.games.length; x < xLen; x++){
						ST_Storage.saveGame(data.games[x].teamId, null, data.games[x].id, data.games[x]);
						gamesAdded++;
					}
				}
				if(data.unsyncedTeams){
					for(var x = 0, xLen = data.unsyncedTeams.length; x < xLen; x++){
						ST_Storage.deleteTeam(data.unsyncedTeams[x]);
					}
				}
				if(data.unsyncedPlayers){
					for(var x = 0, xLen = data.unsyncedPlayers.length; x < xLen; x++){
						ST_Storage.deleteTeamKey(data.unsyncedPlayers[x].teamId,"players", data.unsyncedPlayers[x].id);
					}
				}
				if(data.unsyncedOpponents){
					for(var x = 0, xLen = data.unsyncedOpponents.length; x < xLen; x++){
						ST_Storage.deleteTeamKey(data.unsyncedOpponents[x].teamId,"opponents", data.unsyncedOpponents[x].id);
					}
				}
				if(data.unsyncedGames){
					for(var x = 0, xLen = data.unsyncedGames.length; x < xLen; x++){
						ST_Storage.deleteGame(data.unsyncedGames[x]);
					}
				}
				var msg = $scope.localization.get("addedUpdatedOnYourDevice");
				msg += "\n - " + $scope.localization.get("numTeams", [teamsAdded]);
				msg += "\n - " + $scope.localization.get("numPlayers", [playersAdded]);
				msg += "\n - " + $scope.localization.get("numOpponents", [opponentsAdded]);
				msg += "\n - " + $scope.localization.get("numGames", [gamesAdded]);
				msg += "\n" + $scope.localization.get("addedToAccount");
				msg += "\n - " + $scope.localization.get("numTeams", [data.stats.teamsAdded]);
				msg += "\n - " + $scope.localization.get("numPlayers", [data.stats.playersAdded]);
				msg += "\n - " + $scope.localization.get("numOpponents", [data.stats.opponentsAdded]);
				msg += "\n - " + $scope.localization.get("numGames", [data.stats.gamesAdded]);
				msg += "\n" + $scope.localization.get("updatedOnAccount");
				msg += "\n - " + $scope.localization.get("numTeams", [data.stats.teamsUpdated]);
				msg += "\n - " + $scope.localization.get("numPlayers", [data.stats.playersUpdated]);
				msg += "\n - " + $scope.localization.get("numOpponents", [data.stats.opponentsUpdated]);
				msg += "\n - " + $scope.localization.get("numGames", [data.stats.gamesUpdated]);
				ST_Storage.cleanDeleted();
				setTimeout(function(){ alert(msg)}, 100);
			}
			else{
				switch(data.error){
					case 'invalidAccount':
						alert($scope.localization.get("thatAccountCouldNotBeFound"));
						break;
					default:
						alert(data.error);
						console.log(data, status, headers, config);
				}
			}
		})
		.error(function(data, status, headers, config){
			alert($scope.localization.get("thereWasAErrorConnecting"));
			console.log(data, status, headers, config);
		})
}