'use strict';
angular.module('filters', [])
	.filter('windDirection', function(){
		return function(text){
			text = (((text + 2 * Math.PI + Math.PI / 6) * 100) % 628) / 100; //shift it by pi/6 more radians to make it so that i can compare quarters and not with thirds
			if(text >= 0 && text < Math.PI/4){
				text = "Left to right";
			}
			else if(text >= Math.PI/4 && text < Math.PI/2){
				text = "Away right";
			}
			else if(text >= Math.PI/2 && text < 3 * Math.PI/4){
				text = "Away";
			}
			else if(text >= 3 * Math.PI/4 && text < Math.PI){
				text = "Away left";
			}
			else if(text >= Math.PI && text < Math.PI + Math.PI / 4){
				text = "Right to Left";
			}
			else if(text >= Math.PI + Math.PI/4 && text < Math.PI + Math.PI/2){
				text = "Towards left";
			}
			else if(text >= Math.PI + Math.PI/2 && text < Math.PI + 3 * Math.PI/4){
				text = "Toward";
			}
			else if(text >= Math.PI + 3 * Math.PI/4 && text < Math.PI + Math.PI){
				text = "Towards right";
			}
			return text;
		}
	})
	.filter('windIntensity', function(){
		return function(text){
			return 80 < text ? "Very Strong" : 60 < text ? "Strong" : 40 < text ? "Medium" : 20 < text ? "Light" : "None";
		}
	})
	.filter('isPointHalfTime', function(){
		return function(text, point){
			return Last(point.actions, 1).a === actionTypes.halfTime ? "Half Time" : text;
		}
	})
	.filter('buttonInvert', function(){
		return function(value){
			return value ? "info" : "";
		}
	})
	.filter('iconInvert', function(){
		return function(value){
			return value ? "icon-white" : "";
		}
	})
	.filter('round', function(){
		return function(value){
			return (value ? Math.round(value) : 0);
		}
	})
	.filter('bytesToSize', function(){
		return function(bytes){
			var precision = 2;
			var kilobyte = 1024;
			var megabyte = kilobyte * 1024;
			var gigabyte = megabyte * 1024;
			var terabyte = gigabyte * 1024;
			if(bytes >= terabyte){
				return (bytes / terabyte).toFixed(precision) + ' TB';
			}
			else if(bytes >= gigabyte){
				return (bytes / gigabyte).toFixed(precision) + ' GB';
			}
			else if(bytes >= megabyte){
				return (bytes / megabyte).toFixed(precision) + ' MB';
			}
			else if(bytes >= kilobyte){
				return (bytes / kilobyte).toFixed(precision) + ' KB';
			}
			return bytes + ' B';
		}
	})
	.filter('percentage', function(){
		return function(value){
			return value ? Math.round(value * 1000)/10 + "%" : "--"; //Math.round(input * 1000)/10 + "%";
		};
	});