var scripts = document.getElementsByTagName("script");
var calendarScriptLocation = scripts[scripts.length-1].src.replace("script.js", "");

angular.module('st_calendar', [])
	.service('st_serviceCalendar', function($rootScope, $compile){
		var serviceCalendarScope = this;
		var initialized = false;
		var ngCalendarElement;
		var currentObject;
		var currentKey;
		serviceCalendarScope.init = function(){
			var calendarElement = document.createElement("div");
			ngCalendarElement = angular.element(calendarElement);

			ngCalendarElement.addClass("stCalendarElement");
			calendarElement.setAttribute("id", "st_calendar");

			document.body.appendChild(calendarElement);
			$compile(calendarElement)($rootScope);
			initialized = true;
		};
		serviceCalendarScope.open = function(object, key){
			if(!initialized){ serviceCalendarScope.init(); }

			$rootScope.calendarDate = new Date(1970,0,1);
			$rootScope.calendarDate.setSeconds(object[key] ? object[key] : GetTime());
			$rootScope.originalDate = new Date(1970,0,1);
			$rootScope.originalDate.setSeconds(object[key] ? object[key] : GetTime());

			currentObject = object;
			currentKey = key;

			serviceCalendarScope.toggleCalendar();
		};
		serviceCalendarScope.toggleCalendar = function(seconds){
			ngCalendarElement.toggleClass("show");
			if(seconds){
				currentObject[currentKey] = seconds;
			}
		};
		return this;
	})
	.directive('calendarButton', function(st_serviceCalendar){
			return {
				restrict: 'C',
				link: function(scope, element, attributes){
					element.bind('click', function(){
						if(!attributes.updateObject || !attributes.updateKey|| !scope[attributes.updateObject]){
							alert("You must include an object and a key to update for the calendar");
						}
						else{
							st_serviceCalendar.open(scope[attributes.updateObject], attributes.updateKey);
						}
					})
				}
			};
		})
	.directive('stCalendarElement', function(){
			return {
				restrict: 'C',
				controller: CalendarController,
				scope: true,
				templateUrl: calendarScriptLocation + "index.html?"  + v
			};
		});

function CalendarController($rootScope, $scope, st_serviceCalendar, ST_Localization){
	$scope.calendarDate = $rootScope.calendarDate;
	$scope.deadPreDays = [];
	$scope.monthDays = [];
	$scope.deadPostDays = [];
	$scope.serviceCalendar = st_serviceCalendar;
	$scope.previousMonth = new Date(1970,0,1);
	$scope.currentMonth = new Date(1970,0,1);
	$scope.previousMonthDays = 0;

	$scope.changeMonth = function(direction){
		$scope.calendarDate.setMonth($scope.calendarDate.getMonth() + direction, 1);
		$scope.updateCalendar();
	};
	$scope.save = function(){
		st_serviceCalendar.toggleCalendar(Math.round($scope.originalDate.getTime() / 1000));
	};
	$scope.selectDay = function(day){
		$scope.originalDate.setMonth($scope.calendarDate.getMonth(), day);
		$scope.updateSelected();
	};
	$scope.updateCalendar = function(){
		$scope.currentMonth.setFullYear($scope.calendarDate.getFullYear());
		$scope.currentMonth.setMonth($scope.calendarDate.getMonth());

		$scope.currentMonth.setDate(1);
		$scope.month = ST_Localization.get("month" + $scope.currentMonth.getMonth());
		$scope.year = $scope.currentMonth.getFullYear();
		$scope.deadPreDays.length = $scope.currentMonth.getDay();
		$scope.previousMonth.setMonth($scope.currentMonth.getMonth() - 1);
		$scope.previousMonthDays = $scope.previousMonth.monthDays();
		$scope.monthDays.length = $scope.currentMonth.monthDays();
		$scope.deadPostDays.length = (7 - ($scope.deadPreDays.length + $scope.monthDays.length) % 7) % 7;
		$scope.updateSelected();
	};
	$scope.updateSelected = function(){
		$scope.selected = $scope.originalDate.getFullYear() + '-' + $scope.originalDate.getMonth() + '-' + $scope.originalDate.getDate();
	};
	$scope.updateCalendar();
}