angular.module('localization', [])
		.service('ST_Localization', function($rootScope, $http){
			var localizationScope = this;
			var missingKeys = {};

			var head = document.getElementsByTagName('head')[0];

			localizationScope.availableLocalizations = availableLocalizations;
			localizationScope.currentLocalization = (window.localStorage.getItem('currentLocalization'));

			if(!localizationScope.currentLocalization){
				localizationScope.currentLocalization = "enUs";
			}
			else{
				localizationScope.currentLocalization = JSON.parse(localizationScope.currentLocalization);
			}

			localizationScope.get = function(key, params){
				if(localizationObject[localizationScope.currentLocalization] && localizationObject[localizationScope.currentLocalization][key]){
					delete missingKeys[key];
					var returnString =  localizationObject[localizationScope.currentLocalization][key];
					if(params){
						for(var x = 0, xLen = params.length; x < xLen; x++){
							returnString = returnString.replace("{{" + x + "}}", params[x]);
						}
					}
					return returnString;
				}
				missingKeys[key] = "LOCALIZATION_NOT_FOUND";
				return "LOCALIZATION NOT FOUND";
			};
			localizationScope.getLocalization = function(loc){
				localizationScope.currentLocalization = loc;
				window.localStorage.setItem('currentLocalization', JSON.stringify(localizationScope.currentLocalization));
			};
			localizationScope.Init = function(){
				localizationScope.getLocalization(localizationScope.currentLocalization);
			};
			$rootScope.localization = this;
			return this;
		})
		.filter('localize', function(ST_Localization){
			return function(input, params){
				return ST_Localization.get(input, params);
			};
		});